// ------- scenedir.h

#ifndef SCENEDIR_H
#define SCENEDIR_H

#include "scenery.h"
#include "viddir.h"
#include "linklist.h"
#include "player.h"

class SceneDirector : public SceneryDirector  {
  static SceneDirector *thisscene;
  static int lastsceneid;
  int snapshot;
  virtual void pre_timer_tick()  { }
  virtual void post_timer_tick() { }
  void scanframes();
  friend class Player;
  void addplayer(Player& pl);
  void on_s(int = 0);
protected:
  LinkedList<Player> plist;
  virtual void display();
  virtual void hide();
  virtual void on_timer();
public:
  SceneDirector(char *scfile, short int trans=ClearEveryTime);
  virtual ~SceneDirector() { }
  void ChangeZOrder(Player *p1, Player *p2)
  {
    plist.RemoveEntry(p1);
    plist.InsertEntry(p1, p2);
  }
  void MoveZToFront(Player *p)
  {
    plist.RemoveEntry(p);
    plist.AppendEntry(p);
  }
};

#endif

